<?php 
require_once(drupal_get_path('module', 'fengafim_rules').'/drupal.xmlrpc.inc' );

function disable_site($nid){
	watchdog('Fengafim Status', 'Disabling Site '.$node->title);
	$node = node_load(array('nid' => $nid));
	global $user;
	if(user_access('disable own site', $user) && $user->uid == $node->uid || user_access('disable any site', $user) ){
		watchdog('Fengafim Status', 'Disabling Site '.$node->title.' action granted');
		require_once(drupal_get_path('module', 'fengafim_rules').'/drupal.xmlrpc.inc' );
		$aegir = new DrupalXMLrpc(variable_get('fengafim_domain_access', ''), 
		variable_get('fengafim_api_key', ''), 
		variable_get('fengafim_aegir_address', '').'/services/xmlrpc', TRUE);
		
		
		if ( isset($aegir->session_id) ) {	
			$RemoteUser = $aegir->userLogin(variable_get('fengafim_username', 'admin'), 
			variable_get('fengafim_password', '!madison01') );
		    $result = $aegir->send('task.create', array($node->title, 'disable'));
		   
		} else {
			watchdog('Fengafim Status', 'Recieved no Session id when attempting to disable site.');
		}
		// return success or fail message for dialog
		return $result;
	} 
}

function enable_site($nid){
	$node = node_load(array('nid' => $nid));
	global $user;
	watchdog('Fengafim Status', 'Attempting to Enable Site '.$node->title);
	if( user_access('enable own site', $user) && $user->uid == $node->uid || user_access('enable any site', $user) ){
		if( $node->disabled_by_fengafim !== 1 ){
			watchdog('Fengafim Status', 'Enabling Site '.$node->title);
			$aegir = new DrupalXmlrpc(variable_get('fengafim_domain_access', '' ), 
			variable_get('fengafim_api_key', ''), variable_get('fengafim_aegir_address', '')
			.variable_get('fengafim_preferred_service', '/services/xmlrpc'), TRUE );
			if ( isset($aegir->session_id) ) {
					$RemoteUser = $aegir->userLogin(variable_get('fengafim_username', 'admin'), 
				variable_get('fengafim_password', '!madison01') );
			    $result = $aegir->send('task.create', array($node->title, 'enable'));
			}
			// return success or fail message for dialog
			return $result;
		} else {
			watchdog('Fengafim Status', 'Attempting to Enable Locked Site '.$node->title);
		
		}
	} else {
		watchdog('Fengafim Access Denied', 'Access to enable site '. $node->title .' denied for '.l($user->name, 'user/'.$user->uid) );
	}
}

function lock_site($nid){
	global $user;
	if(user_access('lock any site', $user )){
		$node = node_load(array('nid' => $nid));
		$node->disabled_by_fengafim = 1;
		node_save($node);
		$aegir = new DrupalXmlrpc(variable_get('fengafim_domain_access', '' ), 
		variable_get('fengafim_api_key', ''), variable_get('fengafim_aegir_address', '')
		.variable_get('fengafim_preferred_service', '/services/xmlrpc'), TRUE );
		if ( isset($aegir->session_id) ) {	
			$RemoteUser = $aegir->userLogin(variable_get('fengafim_username', 'admin'), 
				variable_get('fengafim_password', '!madison01') );
		    $result = $aegir->send('task.create', array($node->title, 'disable'));
		}
		// return success or fail message for dialog
		return $result;
	}
}

function unlock_site($nid){
	global $user;
	if(user_access('unlock any site', $user)){
		$node = node_load(array('nid' => $nid));
		$node->disabled_by_fengafim = 0;
		node_save($node);
		$aegir = new DrupalXmlrpc(variable_get('fengafim_domain_access', '' ), 
		variable_get('fengafim_api_key', ''), variable_get('fengafim_aegir_address', '')
		.variable_get('fengafim_preferred_service', '/services/xmlrpc'), TRUE );
		if ( isset($aegir->session_id) ) {	
			$RemoteUser = $aegir->userLogin(variable_get('fengafim_username', 'admin'), 
				variable_get('fengafim_password', '!madison01') );
		    $result = $aegir->send('task.create', array($node->title, 'enable'));
		}
		// return success or fail message for dialog
		return $result;
	}
}

function site_status($nid){
	$node = node_load(array('nid' => $nid));
	$aegir = new DrupalXmlrpc(variable_get('fengafim_domain_access', '' ), 
	variable_get('fengafim_api_key', ''), variable_get('fengafim_aegir_address', '')
	.variable_get('fengafim_preferred_service', '/services/xmlrpc'), TRUE );
	if ( isset($aegir->session_id) ) {
		$RemoteUser = $aegir->userLogin(variable_get('fengafim_username', 'admin'), 
			variable_get('fengafim_password', '!madison01') );
		$result = $aegir->send('site.get', $node->title, '');
	}
	watchdog('Fengafim Status', 'Site Status: '.$result['site_status']);
	switch($result['site_status']){
		case 0:
			return '<span id="status_value">Pending</span>';
		break;
		case 1:
			return '<span id="status_value">Live</span>';
			break;
		case -1:
			return '<span id="status_value">Offline</span>';
			break;
		
	}
	return true; 
}

function delete_site($nid){
	
	$node = node_load(array('nid' => $nid));
	global $user;
	if($user->uid == $node->uid && user_access('delete own site', $user) || user_access('delete any site', $user)){
		$aegir = new DrupalXmlrpc(variable_get('fengafim_domain_access', '' ), 
		variable_get('fengafim_api_key', ''), variable_get('fengafim_aegir_address', '')
		.variable_get('fengafim_preferred_service', '/services/xmlrpc'), TRUE );
		if ( isset($aegir->session_id) ) {	
			$RemoteUser = $aegir->userLogin(variable_get('fengafim_username', 'admin'), 
				variable_get('fengafim_password', '!madison01') );
		    $result = $aegir->send('task.create', array($node->title, 'delete'));
			node_delete($node->nid);
		}
		
		// return success or fail message for dialog
		return true;
	}
}

function clone_site($nid, $new_url){
	global $user;
	$node = node_load( array('nid' => $nid) );
	if($user->uid == $node->uid && user_access('clone own site', $user) || user_access('clone any site', $user) ){
		$node->clone_site = $node->nid;
		$node->type ='clone_site';
		$node->site_nid = '';
		$node->nid = 0;
		$node->uid = $user->uid;
		$aegir = new DrupalXmlrpc(variable_get('fengafim_domain_access', '' ), 
		variable_get('fengafim_api_key', ''), variable_get('fengafim_aegir_address', '')
		.variable_get('fengafim_preferred_service', '/services/xmlrpc'), TRUE );
		if ( isset($aegir->session_id) ) {	
			$RemoteUser = $aegir->userLogin(variable_get('fengafim_username', 'admin'), 
				variable_get('fengafim_password', '!madison01') );
		    $result = $aegir->send('task.create', array($node->title, 'clone', array($new_url)));
		}
		node_save($node);
		return true;
	} else {
		// handling for Customers -> devs goes here !	
	}
	
}

function fengafim_db_size($url){
		$aegir = new DrupalXmlrpc(variable_get('fengafim_domain_access', '' ), 
		variable_get('fengafim_api_key', ''), variable_get('fengafim_aegir_address', '')
		.variable_get('fengafim_preferred_service', '/services/xmlrpc'), TRUE );
		if ( isset($aegir->session_id) ) {	
			$RemoteUser = $aegir->userLogin(variable_get('fengafim_username', 'admin'), 
				variable_get('fengafim_password', '!madison01') );
		    $result = $aegir->send('site.db_size', array($url) );
		}
		
		return $result;
}

function fengafim_file_size($url){
		$aegir = new DrupalXmlrpc(variable_get('fengafim_domain_access', '' ), 
		variable_get('fengafim_api_key', ''), variable_get('fengafim_aegir_address', '')
		.variable_get('fengafim_preferred_service', '/services/xmlrpc'), TRUE );
		if ( isset($aegir->session_id) ) {	
			$RemoteUser = $aegir->userLogin(variable_get('fengafim_username', 'admin'), 
				variable_get('fengafim_password', '!madison01') );
		    $result = $aegir->send('site.file_size', array($url) );
		}
		
		return $result;
}

?>